﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;

namespace Sample
{
    class Program
    {
        static void Main(string[] args)
        {
            //Create a new Word document
            WordDocument document = new WordDocument();
            //Add new section to the document
            IWSection section = document.AddSection();
            //Add new paragraph to section
            IWParagraph paragraph = section.AddParagraph();
            //Create a new instance of IF field
            WIfField field = paragraph.AppendField("IF", FieldType.FieldIf) as WIfField;
            //Specifies the field code
            field.FieldCode = "IF ";
            //Get the index of the If field
            int fieldIndex = paragraph.Items.IndexOf(field);
            //To insert the If field condition after "IF" field code, change the index.
            fieldIndex += 2;
            //Add field code condition for IF field expression.
            WTextRange text = new WTextRange(document);
            text.Text = "1 = 1 ";
            //Insert the If field condition as text
            paragraph.Items.Insert(fieldIndex, text);
            //To insert the merge field after If field condition, change the index.
            fieldIndex += 1;
            InsertMergeField("True", fieldIndex, paragraph);
            //Increase the index based on Merge field.
            fieldIndex += 5;
            //Remaining field code for IF field expression.
            text = new WTextRange(document);
            text.Text = " \"Fail\"";
            //Insert the If field result as text
            paragraph.Items.Insert(fieldIndex, text);            
            //Execute Mail merge
            string[] fieldName = { "True" };
            string[] fieldValue = { "Pass" };            
            document.MailMerge.Execute(fieldName, fieldValue);
            //Updates the document fields
            document.UpdateDocumentFields();
            //Save and close the document
            document.Save("Sample.docx", FormatType.Docx);
            document.Close();
            System.Diagnostics.Process.Start("Sample.docx");            
        }

        private static void InsertMergeField(string fieldName, int fieldIndex, IWParagraph paragraph)
        {
            WParagraph para = new WParagraph(paragraph.Document);
            para.AppendField(fieldName, FieldType.FieldMergeField);
            for(int i = para.ChildEntities.Count - 1; i >= 0; i--)
            {
                paragraph.ChildEntities.Insert(fieldIndex, para.ChildEntities[i]);
            }
        }
    }
}
